import logo from './logo.svg';
import React, { useState, useEffect, useRef } from 'react';
import './App.scss';

const Spoiler = ({ children }) => {
    const [open, setOpen] = useState(false)
    return (
        <div>
            <button onClick={() => setOpen(!open)}>{open ? '^' : 'v'}</button>
            {open && <div>{children}</div>}
        </div>
    )
}

const Timer = ({ count }) => {
    const [paused, setPaused] = useState(false);
    let interval = 100;
    let [cnt, setCnt] = useState(count * interval);
    useEffect(() => {
        if (!paused && cnt > 0) {
            setTimeout(() => setCnt(cnt - 1), 1000 / interval);
        }
    })
    let totalSeconds = parseInt(cnt / interval);
    let hours = parseInt(totalSeconds / 3600);
    let mins = parseInt((totalSeconds - hours * 3600) / 60);
    let seconds = parseInt(totalSeconds - hours * 3600 - mins * 60);
    return (
        <>
            {hours} : {mins} : {seconds}
            <button onClick={() => cnt > 0 ? setPaused(!paused) : setCnt(count * interval)}>{paused || cnt === 0 ? 'Start' : 'Pause'}</button>
        </>
    );
}

function App() {

    return (
        <>
            <div className="App">
                <Timer count={10} />
            </div>
        </>
    );
}

export default App;
